
#include "texture.h"
#include <SDL2/SDL_error.h>	  // Para SDL_GetError
#include <SDL2/SDL_surface.h> // Para SDL_CreateRGBSurfaceWithFormatFrom
#include <fcntl.h>			  // Para SEEK_END, SEEK_SET
#include <stdio.h>			  // Para fseek, fclose, fopen, fread, ftell, FILE
#include <stdlib.h>			  // Para free, malloc
#include <fstream>			  // Para basic_ostream, operator<<, basic_ifstream
#include <iostream>			  // Para cerr, cout
#include <stdexcept>		  // Para runtime_error
#include "gif.c"			  // Para LoadGif, LoadPalette
#include "utils.h"			  // Para getFileName, printWithDots

#define STB_IMAGE_IMPLEMENTATION
#include "stb_image.h" // para stbi_failure_reason, stbi_image_free

// Constructor
Texture::Texture(SDL_Renderer *renderer, const std::string &path)
	: renderer_(renderer),
	  path_(path)
{
	// Carga el fichero en la textura
	if (!path_.empty())
	{
		// Obtiene la extensión
		const std::string extension = path_.substr(path_.find_last_of(".") + 1);

		// .png
		if (extension == "png")
		{
			loadFromFile(path_);
		}

		// .gif
		else if (extension == "gif")
		{
			// Crea la surface desde un fichero
			surface_ = loadSurface(path_);

			// Añade la propia paleta del fichero a la lista
			addPaletteFromFile(path_);
			// setPaletteColor(0, 0, 0x00000000);

			// Crea la textura, establece el BlendMode y copia la surface a la textura
			createBlank(width_, height_, SDL_PIXELFORMAT_RGBA8888, SDL_TEXTUREACCESS_STREAMING);
			SDL_SetTextureBlendMode(texture_, SDL_BLENDMODE_BLEND);
			flipSurface();
		}
	}
}

// Destructor
Texture::~Texture()
{
	unloadTexture();
	unloadSurface();
	palettes_.clear();
}

// Carga una imagen desde un fichero
bool Texture::loadFromFile(const std::string &file_path)
{
	if (file_path.empty())
		return false;

	int req_format = STBI_rgb_alpha;
	int width, height, orig_format;
	unsigned char *data = stbi_load(file_path.c_str(), &width, &height, &orig_format, req_format);
	if (!data)
	{
		std::cerr << "Error: Fichero no encontrado " << getFileName(file_path) << std::endl;
		throw std::runtime_error("Fichero no encontrado: " + getFileName(file_path));
	}
	else
	{
		printWithDots("Image : ", getFileName(file_path), "[ LOADED ]");
	}

	int depth, pitch;
	Uint32 pixel_format;
	/*if (req_format == STBI_rgb)
	{
		depth = 24;
		pitch = 3 * width; // 3 bytes por pixel * pixels por linea
		pixel_format = SDL_PIXELFORMAT_RGB24;
	}
	else*/
	{ // STBI_rgb_alpha (RGBA)
		depth = 32;
		pitch = 4 * width;
		pixel_format = SDL_PIXELFORMAT_RGBA32;
	}

	// Limpia
	unloadTexture();

	// La textura final
	SDL_Texture *newTexture = nullptr;

	// Carga la imagen desde una ruta específica
	auto loadedSurface = SDL_CreateRGBSurfaceWithFormatFrom(static_cast<void *>(data), width, height, depth, pitch, pixel_format);
	if (loadedSurface == nullptr)
	{
		std::cout << "Unable to load image " << file_path << std::endl;
	}
	else
	{
		// Crea la textura desde los pixels de la surface
		newTexture = SDL_CreateTextureFromSurface(renderer_, loadedSurface);
		if (newTexture == nullptr)
		{
			std::cout << "Unable to create texture from " << file_path << "! SDL Error: " << SDL_GetError() << std::endl;
		}
		else
		{
			// Obtiene las dimensiones de la imagen
			width_ = loadedSurface->w;
			height_ = loadedSurface->h;
		}

		// Elimina la textura cargada
		SDL_FreeSurface(loadedSurface);
	}

	// Return success
	stbi_image_free(data);
	texture_ = newTexture;
	return texture_ != nullptr;
}

// Crea una textura en blanco
bool Texture::createBlank(int width, int height, SDL_PixelFormatEnum format, SDL_TextureAccess access)
{
	// Crea una textura sin inicializar
	texture_ = SDL_CreateTexture(renderer_, format, access, width, height);
	if (!texture_)
	{
		std::cout << "Unable to create blank texture! SDL Error: " << SDL_GetError() << std::endl;
	}
	else
	{
		width_ = width;
		height_ = height;
	}

	return texture_ != nullptr;
}

// Libera la memoria de la textura
void Texture::unloadTexture()
{
	// Libera la textura
	if (texture_)
	{
		SDL_DestroyTexture(texture_);
		texture_ = nullptr;
		width_ = 0;
		height_ = 0;
	}
}

// Establece el color para la modulacion
void Texture::setColor(Uint8 red, Uint8 green, Uint8 blue)
{
	SDL_SetTextureColorMod(texture_, red, green, blue);
}

// Establece el blending
void Texture::setBlendMode(SDL_BlendMode blending)
{
	SDL_SetTextureBlendMode(texture_, blending);
}

// Establece el alpha para la modulación
void Texture::setAlpha(Uint8 alpha)
{
	SDL_SetTextureAlphaMod(texture_, alpha);
}

// Renderiza la textura en un punto específico
void Texture::render(int x, int y, SDL_Rect *clip, float zoomW, float zoomH, double angle, SDL_Point *center, SDL_RendererFlip flip)
{
	// Establece el destino de renderizado en la pantalla
	SDL_Rect renderQuad = {x, y, width_, height_};

	// Obtiene las dimesiones del clip de renderizado
	if (clip != nullptr)
	{
		renderQuad.w = clip->w;
		renderQuad.h = clip->h;
	}

	renderQuad.w = renderQuad.w * zoomW;
	renderQuad.h = renderQuad.h * zoomH;

	// Renderiza a pantalla
	SDL_RenderCopyEx(renderer_, texture_, clip, &renderQuad, angle, center, flip);
}

// Establece la textura como objetivo de renderizado
void Texture::setAsRenderTarget(SDL_Renderer *renderer)
{
	SDL_SetRenderTarget(renderer, texture_);
}

// Obtiene el ancho de la imagen
int Texture::getWidth()
{
	return width_;
}

// Obtiene el alto de la imagen
int Texture::getHeight()
{
	return height_;
}

// Recarga la textura
bool Texture::reLoad()
{
	return loadFromFile(path_);
}

// Obtiene la textura
SDL_Texture *Texture::getSDLTexture()
{
	return texture_;
}

// Desencadenar la superficie actual
void Texture::unloadSurface()
{
	surface_.reset(); // Resetea el shared_ptr
	width_ = 0;
	height_ = 0;
}

// Crea una surface desde un fichero .gif
std::shared_ptr<Surface> Texture::loadSurface(const std::string &file_path)
{
	// Desencadenar la superficie actual
	unloadSurface();

	// Abrir el archivo usando std::ifstream para manejo automático del recurso
	std::ifstream file(file_path, std::ios::binary | std::ios::ate);
	if (!file)
	{
		std::cerr << "Error: Fichero no encontrado " << file_path << std::endl;
		throw std::runtime_error("Fichero no encontrado: " + file_path);
	}

	// Obtener el tamaño del archivo
	std::streamsize size = file.tellg();
	file.seekg(0, std::ios::beg);

	// Leer el contenido del archivo en un buffer
	std::vector<Uint8> buffer(size);
	if (!file.read(reinterpret_cast<char *>(buffer.data()), size))
	{
		std::cerr << "Error al leer el fichero " << file_path << std::endl;
		throw std::runtime_error("Error al leer el fichero: " + file_path);
	}

	// Cerrar el archivo (automáticamente manejado por std::ifstream)
	file.close();

	// Llamar a la función LoadGif
	Uint16 w, h;
	Uint8 *rawPixels = LoadGif(buffer.data(), &w, &h);
	if (!rawPixels)
	{
		return nullptr;
	}

	// Crear un std::shared_ptr con std::make_shared para pixels
	auto pixels = std::shared_ptr<Uint8[]>(rawPixels, std::default_delete<Uint8[]>());
	auto surface = std::make_shared<Surface>(w, h, pixels);

	// Actualizar la anchura y altura
	width_ = w;
	height_ = h;

	return surface;
}

// Vuelca la surface en la textura
void Texture::flipSurface()
{
	// Limpia la textura
	auto temp = SDL_GetRenderTarget(renderer_);
	SDL_SetRenderTarget(renderer_, texture_);
	SDL_SetRenderDrawColor(renderer_, 0, 0, 0, 0);
	SDL_RenderClear(renderer_);
	SDL_SetRenderTarget(renderer_, temp);

	// Vuelca los datos
	Uint32 *pixels;
	int pitch;
	SDL_LockTexture(texture_, nullptr, reinterpret_cast<void **>(&pixels), &pitch);
	for (int i = 0; i < width_ * height_; ++i)
	{
		pixels[i] = palettes_[current_palette_][surface_->data[i]];
	}
	SDL_UnlockTexture(texture_);
}

// Establece un color de la paleta
void Texture::setPaletteColor(int palette, int index, Uint32 color)
{
	palettes_.at(palette)[index] = color;
}

// Carga una paleta desde un fichero
std::vector<Uint32> Texture::loadPaletteFromFile(const std::string &file_path)
{
	std::vector<Uint32> palette;

	FILE *f = fopen(file_path.c_str(), "rb");
	if (!f)
	{
		std::cerr << "Error: Fichero no encontrado " << getFileName(file_path) << std::endl;
		throw std::runtime_error("Fichero no encontrado: " + getFileName(file_path));
	}
	else
	{
		printWithDots("Image : ", getFileName(file_path), "[ LOADED ]");
	}

	fseek(f, 0, SEEK_END);
	long size = ftell(f);
	fseek(f, 0, SEEK_SET);
	Uint8 *buffer = static_cast<Uint8 *>(malloc(size));
	fread(buffer, size, 1, f);
	fclose(f);

	const auto *pal = LoadPalette(buffer);
	if (!pal)
	{
		return palette;
	}

	free(buffer);

	for (int i = 0; i < 256; ++i)
	{
		palette.push_back((pal[i] << 8) + 255);
	}

	return palette;
}

// Añade una paleta a la lista
void Texture::addPaletteFromFile(const std::string &path)
{
	palettes_.emplace_back(loadPaletteFromFile(path));
	setPaletteColor((int)palettes_.size() - 1, 0, 0x00000000);
}

// Cambia la paleta de la textura
void Texture::setPalette(int palette)
{
	if (palette < (int)palettes_.size())
	{
		current_palette_ = palette;
		flipSurface();
	}
}

// Obtiene el renderizador
SDL_Renderer *Texture::getRenderer()
{
	return renderer_;
}